#!/usr/bin/perl -w -s

use Device::SerialPort;

system("stty -F /dev/ttyS18 115200 cs8 raw");
#system("stty -F /dev/ttyS10 115200 cs8 raw");
#open( $COM, "+<","/dev/ttyS10") or die "Can't read serial port : $!\n";
open INFILE, "/dev/ttyS18"
   or die "\nCannot open /dev/ttyUSB0!\n";
$ADC=1023;
$VCAL=147.54;
$PHASECAL=1.7; 
$offsetV= $ADC>>1;
$ICAL=57.806;  
$offsetI=$ADC>>1;
$crossings=2000;   
$lastFilteredV=0;   
my $port = Device::SerialPort->new("/dev/ttyS0");

$port->baudrate(115200); # Configure this to match your device
$port->databits(8);
$port->parity("none");
$port->stopbits(1);
$timeout = 2000;
@data = ();
$buf = "";
$cnt = 0;
$started = 0;
$st= 0;
  $SupplyVoltage=5000;
  $crossCount = 0;
  $numberOfSamples = 0;
$numberOfSamples=0;

sub processPacket($);

while (read(INFILE, $buf, 1)) {
  $d = ord($buf)  ;
  if ($d == 0xaa && $started == 0) {
    $started = 1;
    $a = 0;
  }
  if ($started == 1) {
    $data[$a] = $d;
    $sum += $data[$a];
 #   printf("0x%02X ", $data[$a]);
     
    $a++;
    if ($a >= 17) {
     # $sum -= $data[16];
     # $sum &= 0xff;
     $sum = 0;
      if ($sum == 0) { processPacket($data); }
      $started=1;
      $a = 0;
     # print "\n";
    }
  }
}
 
  # Working sub process packet stuff
  sub processPacket($) {
  local($data) = @_;
  #  If the power reading is way off, uncomment the other power line
  # $power = (($data[5]^0xff)<<8) + ($data[4]^0xff);
    $A0 = ($data[1]<<8) + $data[2];
    $A1 = ($data[3]<<8) + $data[4];
    $A2 = ($data[5]<<8) + $data[6];
    $A3 = ($data[7]<<8) + $data[8];
    $A4 = ($data[9]<<8) + $data[10];
    $A5 = ($data[11]<<8) + $data[12];
    $A6 = ($data[13]<<8) + $data[14];
    $A7 = ($data[15]<<8) + $data[16];

   #print "$A0,$A1,$A2,$A3,$A4.$A5,$A6,$A7\n";
$port->write("$A0,$A1,$A2,$A3,$A4.$A5,$A6,$A7\n");

 $startV=$A3;
# print "$startV\r";
                      
    if (($startV< ($ADC*0.55)) && ($startV > ($ADC*0.45))) {
     $st=1; 
 # print "true\n";
    }

if($st==1) {   
if ($crossCount < $crossings) { 
  
 $numberOfSamples++ ; 
 
 #print "$crossCount\r";
 #print "$numberOfSamples\n";
 $lastFilteredV = $filteredV;
 $sampleV =$A3;
 $sampleI = $A0;
 
 $offsetV = $offsetV + (($sampleV-$offsetV)/1024);
    $filteredV = $sampleV - $offsetV;
    $offsetI = $offsetI + (($sampleI-$offsetI)/1024);
    $filteredI = $sampleI - $offsetI;
    
    $sqV= $filteredV * $filteredV;                
    $sumV += $sqV;
    
    $sqI = $filteredI * $filteredI;                
    $sumI += $sqI;
    
  $phaseShiftedV = $lastFilteredV + $PHASECAL * ($filteredV - $lastFilteredV);

  $instP = $phaseShiftedV * $filteredI;          
    $sumP += $instP;
    
    
      $lastVCross = $checkVCross;
    if ($sampleV > $startV){ $checkVCross = 1;}
                     else {$checkVCross = 0;}
    if ($numberOfSamples==1) {$lastVCross = $checkVCross;}

    if ($lastVCross != $checkVCross) {$crossCount++;}
  
}
#else {$st=0;}
}
$cnt4++;

if($cnt4==$crossings ) {
#print " $numberOfSamples\n";
 $VRATIO = $VCAL *(($SupplyVoltage/1000.0) / ($ADC));
  $Vrms = $VRATIO * sqrt($sumV / $numberOfSamples);
  print "Volts, $Vrms\n";
  $IRATIO = $ICAL *(($SupplyVoltage/1000.0) / ($ADC));
  $Irms = $IRATIO * sqrt($sumI / $numberOfSamples);
  print "irms, $Irms\n";
  
  $realPower = $VRATIO * $IRATIO * $sumP / $numberOfSamples;
  print "real, $realPower\n";
  $apparentPower = $Vrms * $Irms;
  print "apparent, $apparentPower\n";
  $powerFactor=$realPower / $apparentPower;
  print "PF, $powerFactor\n";
   print "\n";
  
  $st=0;
  $SupplyVoltage=5000;
  $crossCount = 0;
  $numberOfSamples = 0;
  $cnt4=0;
  $sumV = 0;
  $sumI = 0;
  $sumP = 0;
}

  }
close INFILE; 
